<?php

namespace PME\Services;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\Session\Session;
use Teknisa\Libs\Util\Utilities;

class ConnectionFactory extends \Zeedhi\Framework\ORM\ConnectionFactory {

    /**
     * @param Connection $connection
     * @param Session $session
     * @throws \Exception
     */
    public static function insertSQLWebTunning($connection, $session) {
        try {
            if(Utilities::getUseSQLWebTunningParameter()) {
                $query = "INSERT INTO SQLWEBTUNNING (DSREMOTEADDR, DSREMOTEHOST, DSREMOTEAPPL, DSSERVERRDM,
                                                     DSSERVERDLL,  DTSTARTDATE,  DSREMOTEOPER, DSSERVMETHOD)
                               VALUES (:DSREMOTEADDR, :DSREMOTEHOST, :DSREMOTEAPPL, :DSSERVERRDM,
                                       :DSSERVERDLL,  SYSDATE,       :DSREMOTEOPER, :DSSERVMETHOD)";

                $host       = isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME'];
                $requestUri = explode('index.php', trim($_SERVER['REQUEST_URI']));
                $route      = array_pop($requestUri);
                $cdoperador = $session && $session->has('CDOPERADOR') ? $session->has('CDOPERADOR') : 'SESSAO_N_INI';
                $hostArr    = explode('.', $host);
                $hostInit   = array_shift($hostArr);
                
                $params = array (
                    'DSREMOTEADDR' => trim(substr(gethostbyname($host), 0, 15)),
                    'DSREMOTEHOST' => trim(substr($hostInit, 0, 15)),
                    'DSREMOTEAPPL' => strval(Utilities::getProjectIdParameter()),
                    'DSSERVERRDM'  => trim(implode('.', $hostArr)),
                    'DSSERVERDLL'  => 'ZEEDHI_REQUEST',
                    'DSREMOTEOPER' => $cdoperador,
                    'DSSERVMETHOD' => substr($route, 0, 30)
                );
                $connection->executeQuery($query, $params);
            }
        } catch(\Exception $e) {}
    }
}