<?php

namespace Relatione\Logic;
/**
 * Created by JetBrains PhpStorm.
 * User: marcellichtnow
 * Date: 12/04/13
 * Time: 09:47
 * To change this template use File | Settings | File Templates.
 */

class AssistenteAgendaLogic
{

    private $_parcNegocioEntity;
    private $_filaContatoEntity;
    private $_tipoParcnegocio;
    private $_tipo;
    private $_comoChegou;
    private $_qualific;
    private $_nrFuncini;
    private $_nrFuncfim;
    private $_vrFaturaini;
    private $_vrFaturafim;
    private $_segMer;
    private $_ramo;
    private $_pais;
    private $_estado;
    private $_municipio;

    private $_nrPrioridade;
    private $_cdOperadorReal;
    private $_dtPlanejamento;
    private $_nrContatos;
    private $_dsContato;


    public function __construct(){
        $this->_parcNegocioEntity = new \Geral\Entities\Parcnegocio();
        $this->_filaContatoEntity = new \Relatione\Entities\Filacontato();
    }


    public function filtroAssistente()
    {
        $select = "";
        $innerjoin = "";
        $where = "";
        $parceirim = $this->_tipoParcnegocio;
        switch ($this->_tipoParcnegocio)
        {
            case \Geral\Entities\Tipoparceiro::CLIENTE:
                $select = ",CLIE.IDPRIPUBCLIE AS TIPO,
                            CLIE.CDQUALIF     AS QUALIFICACAO,
                            CLIE.NRFUNCCLIE   AS NRFUNCIONARIOS,
                            CLIE.VRFATUCLIE   AS VALORFATURAMENTO,
                            CLIE.CDATIVCLI    AS RAMOATIVIDADE";

                $innerjoin ="LEFT JOIN CLIENTE CLIE ON (PN.NRPARCNEGOCIO = CLIE.NRPARCNEGOCIO
                             AND PN.NRORG = CLIE.NRORG AND PN.CDSEGMER = CLIE.CDSEGMER)";

                $where ="WHERE PN.IDATIVO ='S'";

                $this->_tipoParcnegocio? $where .=" AND PN.CDTIPOPARCPRINCIPAL ="."'".\Geral\Entities\Tipoparceiro::CLIENTE."'": $where .= "";
                $this->_tipo? $where .=" AND CLIE.IDPRIPUBCLIE ='$this->_tipo'": $where .= "";
                $this->_qualific? $where .=" AND CLIE.CDQUALIF ='$this->_qualific'": $where .= "";
                if (($this->_nrFuncini!='')&&($this->_nrFuncfim!=''))
                {
                    $where .= " AND TO_NUMBER(CLIE.NRFUNCCLIE) BETWEEN $this->_nrFuncini AND $this->_nrFuncfim";
                }
                else
                {
                    if (($this->_nrFuncini!='')&&($this->_nrFuncfim==''))
                    {
                        $where .=" AND TO_NUMBER(CLIE.NRFUNCCLIE) >= $this->_nrFuncini";
                    }
                    else
                    {
                        if (($this->_nrFuncini=='')&&($this->_nrFuncfim!=''))
                        {
                            $where .=" AND TO_NUMBER(CLIE.NRFUNCCLIE) <= $this->_nrFuncfim";
                        }
                        else
                        {
                            $where .= "";
                        }
                    }
                }
                if (($this->_vrFaturaini!='')&&($this->_vrFaturafim!=''))
                {
                    $where .= " AND CLIE.VRFATUCLIE BETWEEN '$this->_vrFaturaini' AND '$this->_vrFaturafim'";
                }
                else
                {
                    if (($this->_vrFaturaini!='')&&($this->_vrFaturafim==''))
                    {
                        $where .=" AND CLIE.VRFATUCLIE >= '$this->_vrFaturaini'";
                    }
                    else
                    {
                        if (($this->_vrFaturaini=='')&&($this->_vrFaturafim!=''))
                        {
                            $where .=" AND CLIE.VRFATUCLIE <= '$this->_vrFaturafim'";
                        }
                        else
                        {
                            $where .= "";
                        }
                    }
                }
                $this->_segMer? $where .=" AND CLIE.CDSEGMER = '$this->_segMer'": $where .= "";
                $this->_ramo? $where .=" AND CLIE.CDATIVCLI = '$this->_ramo'": $where .= "";
                break;

            case \Geral\Entities\Tipoparceiro::PROSPECT:
                $select = ",PROSP.IDPRIPUBPROS AS TIPO,
                            PROSP.CDQUALIF     AS QUALIFICACAO,
                            PROSP.NRFUNCPROS   AS NRFUNCIONARIOS,
                            PROSP.VRFATUPROS   AS VALORFATURAMENTO,
                            PROSP.CDATIVCLI    AS RAMOATIVIDADE,
                            PROSP.CDMODODIVULG AS MODODIVULGACAO";

                $innerjoin ="LEFT JOIN PROSPECT PROSP ON (PN.NRPARCNEGOCIO = PROSP.NRPARCNEGOCIO
                             AND PN.NRORG = PROSP.NRORG AND PN.CDSEGMER = PROSP.CDSEGMER)";

                $where ="WHERE PN.IDATIVO ='S'";

                $this->_tipoParcnegocio? $where .=" AND PN.CDTIPOPARCPRINCIPAL ="."'".\Geral\Entities\Tipoparceiro::PROSPECT."'": $where .= "";
                $this->_tipo? $where .=" AND PROSP.IDPRIPUBPROS ='$this->_tipo'": $where .= "";
                $this->_comoChegou? $where .=" AND PROSP.CDMODODIVULG ='$this->_comoChegou'": $where .= "";
                $this->_qualific? $where .=" AND PROSP.CDQUALIF ='$this->_qualific'": $where .= "";
                if (($this->_nrFuncini!='')&&($this->_nrFuncfim!=''))
                {
                    $where .= " AND TO_NUMBER(PROSP.NRFUNCPROS) BETWEEN $this->_nrFuncini AND $this->_nrFuncfim";
                }
                else
                {
                    if (($this->_nrFuncini!='')&&($this->_nrFuncfim==''))
                    {
                        $where .=" AND TO_NUMBER(PROSP.NRFUNCPROS) >= $this->_nrFuncini";
                    }
                    else
                    {
                        if (($this->_nrFuncini=='')&&($this->_nrFuncfim!=''))
                        {
                            $where .=" AND TO_NUMBER(PROSP.NRFUNCPROS) <= $this->_nrFuncfim";
                        }
                        else
                        {
                            $where .= "";
                        }
                    }
                }
                if (($this->_vrFaturaini!='')&&($this->_vrFaturafim!=''))
                {
                    $where .= " AND PROSP.VRFATUPROS BETWEEN '$this->_vrFaturaini' AND '$this->_vrFaturafim'";
                }
                else
                {
                    if (($this->_vrFaturaini!='')&&($this->_vrFaturafim==''))
                    {
                        $where .=" AND PROSP.VRFATUPROS >= '$this->_vrFaturaini'";
                    }
                    else
                    {
                        if (($this->_vrFaturaini=='')&&($this->_vrFaturafim!=''))
                        {
                            $where .=" AND PROSP.VRFATUPROS <= '$this->_vrFaturafim'";
                        }
                        else
                        {
                            $where .= "";
                        }
                    }
                }
                $this->_segMer? $where .=" AND PROSP.CDSEGMER = '$this->_segMer'": $where .= "";
                $this->_ramo? $where .=" AND PROSP.CDATIVCLI = '$this->_ramo'": $where .= "";
                break;

            case \Geral\Entities\Tipoparceiro::FORNECEDOR:
                $select = ",FORN.IDPRIPUBFORN AS TIPO,
                            FORN.CDQUALIF     AS QUALIFICACAO";

                $innerjoin ="LEFT JOIN FORNECEDOR FORN ON (PN.NRPARCNEGOCIO = FORN.NRPARCNEGOCIO
                             AND PN.NRORG = FORN.NRORG AND PN.CDSEGMER = FORN.CDSEGMER)";

                $where ="WHERE PN.IDATIVO ='S'";

                $this->_tipoParcnegocio? $where .=" AND PN.CDTIPOPARCPRINCIPAL ="."'".\Geral\Entities\Tipoparceiro::PROSPECT."'": $where .= "";
                $this->_tipo? $where .=" AND FORN.IDPRIPUBFORN ='$this->_tipo'": $where .= "";
                $this->_qualific? $where .=" AND FORN.CDQUALIF ='$this->_qualific'": $where .= "";
                break;



        }

        $this->_pais? $where .=" AND EP.CDPAIS = '$this->_pais'": $where .= "";
        $this->_estado? $where .=" AND UPPER(EP.SGESTADO) = UPPER('$this->_estado')": $where .= "";
        $this->_municipio? $where .=" AND EP.CDMUNICIPIO = '$this->_municipio'": $where .= "";

        $ParcNegocioFacade = new \View\RelatiOne\ParcNegocioFacade();
        $sql= $ParcNegocioFacade->filtroAssistente($select,$innerjoin,$where,$parceirim);
        return $sql;
    }

    // Esta função recebe os como parametro os registros de acordo com o filtro feito e guarda os registros no contexto 'PARCEIROSSELECIONADOS'
    public function setaParceirosSelecionados(array $parceirosSelecionados = null) {
        if(count($parceirosSelecionados)>0)
        {
            tk_set_context_vars('PARCEIROSSELECIONADOS', 'ron33000', $parceirosSelecionados);
        }
    }

    /* @ Esta função faz a rotina para receber os registros e inserilos na tabela de 'FILACONTATO' com as colunas de acordo com os registros selecionados e
     *com os campos digitados*/
    public function gerarAgendamentoEmMassa($nrPrioridade,$cdOperadorReal,$dtPlanejamento,$dsContato,$nrcontatodia) {
        $parceirosSelecionados = tk_get_context_vars('PARCEIROSSELECIONADOS', 'ron33000');//Comentada pois agora sera usado os registros que estao no grid
        $quantOperadores = count($cdOperadorReal);//Contar a quantidade de operadores
        $contTarefas     = count($parceirosSelecionados);//Contar a quantidade de parceiros

        $dtinclusao = now();
        $dtinclusao = \Geral\Util\DateUtil::getDataDeString($dtinclusao,\Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
        $cdoperador = \Geral\Util\Ambiente::getCdOperador();
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $idorigfilaconta = \Relatione\Entities\Filacontato::IDORIGFILACONTA_MANUAL;
        $dtplanejamento = \Geral\Util\DateUtil::getDataDeString($dtPlanejamento, \Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);

        if($quantOperadores > $contTarefas){//Verifica se existe mais operadores do que tarefas
            $contarResul = 0;
            foreach($cdOperadorReal as $operador){//Faz a verificação dentro do foreach para ver qual operador tem mais tarefas
                $sql = "SELECT * FROM FILACONTATO
                               WHERE CDOPERREAL = '".$operador['cdoperador']."'
                                 AND NRORG = ".$nrorg."
                               ORDER BY NRCONTATO DESC";
                $resultado = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
                if($contarResul==0){
                    $cont = count($resultado);
                }
                if(count($resultado) <= $cont ){
                    $cont = count($resultado);
                    $operadorInclu = $operador['cdoperador'];
                }
                $contarResul++;
            }
            $operMax = 'S';
        }else{
            $numOperInser = round($contTarefas/$quantOperadores);//Quantidade de tarefas por operadores
            $operadorInclu = $cdOperadorReal[0]['cdoperador'];
            $contarTarefa = 0;//Contador para verificar o numero correto de registros para a quantidade de operadores escolhidos
            $x = 0;//Contador para pegar o proximo operador da lista de operadores escolhida no reference
            $operMax = 'N';
        }
        $contData = 0;//Contador para verificar quantos dias serao inclusos cada registro de acordo com o numero digitado pelo usuario
        if(count($parceirosSelecionados)>0)
        {
            try {
                foreach ($parceirosSelecionados as $parceiro) {
                    $connection = \Setforms2\Shared\Registry::getEntityManager();
                    $connection->beginTransaction();

                    if($operMax == 'N'){
                        if($contarTarefa == $numOperInser){//Verifica quando tiver mais de um operador e insere a quantidade correta para cada operador
                            $operadorInclu = $cdOperadorReal[$x+1]['cdoperador'];
                            $contarTarefa = 0;
                            if(empty($operadorInclu))
                                $operadorInclu = $cdOperadorReal[$x]['cdoperador'];
                            $x++;
                        }
                    }

                    if($nrcontatodia == $contData){//Faz o calculo da data e insere a quantidade correta para cada cada dia
                        $dtplanejamento = \Geral\Util\DateUtil::adicionaIntervalo($dtplanejamento,1);
                        $contData = 0;
                    }

                    $nrRelacionaParc = \Geral\Logic\RelacionaparcLogic::consultaInterlocutorDoParceiro($parceiro['NRPARCNEGOCIO'], $nrorg);
                    if (is_object($nrRelacionaParc))
                        $nrRelacionaParc = $nrRelacionaParc->getNrrelacionaparc();

                    $nrComunicaParc = \Geral\Logic\ComunicaparcLogic::retornaComunicacaoPrincipalPorParceiro($parceiro['NRPARCNEGOCIO'], $nrorg);
                    if (is_object($nrComunicaParc))
                        $nrComunicaParc = $nrComunicaParc->getNrcomunicaparc();

                    $nrseqfilacontato = tk_get_field_value("NRSEQFILACONTATO");
                    $filaContato = new \Relatione\Entities\Filacontato();

                    /* @var $filaContato \Relatione\Entities\Filacontato */
                    /* @ $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
                    $connection->beginTransaction();*/

                    if(empty($nrseqfilacontato)){
                        $nrseqfilacontato = \Geral\Util\NovoCodigo::geraCodigo(\Geral\Util\Ambiente::getNrorg(), 'FILACONTATO', 1, 10);
                        $filaContato->setNrseqfilaconta($nrseqfilacontato);
                    }
                    if($parceiro['NRPARCNEGOCIO'] != NULL)
                        $filaContato->setNrparcnegocio($parceiro['NRPARCNEGOCIO']);

                    $filaContato->setNrpriorfilacont($nrPrioridade);
                    $filaContato->setCdoperreal($operadorInclu);
                    $filaContato->setDtplanfilaconta($dtplanejamento);
                    $filaContato->setDsfilacontato($dsContato);
                    $filaContato->setNrcontato(NULL);
                    $filaContato->setNrrelacionaparc($nrRelacionaParc);
                    $filaContato->setNrcomunicaparc($nrComunicaParc);
                    $filaContato->setIdorigfilaconta($idorigfilaconta);
                    $filaContato->setNrorg($nrorg);
                    $filaContato->setNrorginclusao($nrorg);
                    $filaContato->setNrorgultatu($nrorg);
                    $filaContato->setCdoperinclusao($cdoperador);
                    $filaContato->setCdoperultatu($cdoperador);
                    $filaContato->setDtinclusao($dtinclusao);
                    $filaContato->setDtultatu($dtinclusao);

                    $filaContato->persist();
                    $connection->flush();
                    $connection->commit();
                    $connection->clear();

                    $contarTarefa++;
                    $contData++;
                }
                tk_message("Agendamento gerado com sucesso!");

            } catch (\Exception $e) {
                tk_warning("Erro ao gerar agendamento em Massa");
                $e->getMessage();
            }
        }
        $window = tk_get_active_window_name();
        tk_set_context_vars('PARCEIROSSELECIONADOS', $window, null);
    }

    public function setComoChegou($comoChegou)
    {
        $this->_comoChegou = $comoChegou;
    }

    public function setEstado($estado)
    {
        $this->_estado = $estado;
    }

    public function setMunicipio($municipio)
    {
        $this->_municipio = $municipio;
    }

    public function setNrFuncfim($nrFuncfim)
    {
        $this->_nrFuncfim = $nrFuncfim;
    }

    public function setNrFuncini($nrFuncini)
    {
        $this->_nrFuncini = $nrFuncini;
    }

    public function setPais($pais)
    {
        $this->_pais = $pais;
    }

    public function setQualific($qualific)
    {
        $this->_qualific = $qualific;
    }

    public function setRamo($ramo)
    {
        $this->_ramo = $ramo;
    }

    public function setSegMer($segMer)
    {
        $this->_segMer = $segMer;
    }

    public function setTipo($tipo)
    {
        $this->_tipo = $tipo;
    }

    public function setTipoParcnegocio($tipoParcnegocio)
    {
        $this->_tipoParcnegocio = $tipoParcnegocio;
    }

    public function setVrFaturafim($vrFaturafim)
    {
        $this->_vrFaturafim = $vrFaturafim;
    }

    public function setVrFaturaini($vrFaturaini)
    {
        $this->_vrFaturaini = $vrFaturaini;
    }

    public function setCdOperadorReal($cdOperadorReal)
    {
        $this->_cdOperadorReal = $cdOperadorReal;
    }

    public function setDsContato($dsContato)
    {
        $this->_dsContato = $dsContato;
    }

    public function setDtPlanejamento($dtPlanejamento)
    {
        $this->_dtPlanejamento = $dtPlanejamento;
    }

    public function setNrContatos($nrContatos)
    {
        $this->_nrContatos = $nrContatos;
    }

    public function setNrPrioridade($nrPrioridade)
    {
        $this->_nrPrioridade = $nrPrioridade;
    }

}
